#!/usr/bin/perl
package Kline::Config;
# Config.pm
# Chris Kline; chris.kline@ca.com
# Copyright CA Technologies, Inc. 2011 All Rights Reserved
# ---------------------------------------------------------------------------
#
# This script is a library of commonly used functions for Kline programs that
# use Perl.  It can be "sourced in" using the "require" pragma.
# This library contains only functions that perform display-related activities.
# These functions may call functions from other libraries.
#
# ---------------------------------------------------------------------------
# REVISION HISTORY
# 1.0.0  12/05/11 Initial.
#
#-------------------------------------------------------------------------------
# Source Control Information
# $Revision: 22 $
# $LastChangedDate: 2012-01-10 20:43:31 -0700 (Tue, 10 Jan 2012) $
# $Author: cnkline $
#
# ---------------------------------------------------------------------------
# INITIALIZE THE ENVIRONMENT

use strict;
use English; 		#D:\perl_oreilly\prog\ch07_013.htm
require Exporter;
our @ISA=qw(Exporter);
our @EXPORT=qw();

use Kline::Display;
use Config::General qw(ParseConfig SaveConfig SaveConfigString);
use Data::Dumper;

use lib '..'; #so we can run these direct to make sure they compile and not fail for missing mods
use Kline::Utils;

my $scriptVer="1.0";
my $scriptDate; #backward compatibility
($scriptDate = '$LastChangedDate: 2012-01-10 20:43:31 -0700 (Tue, 10 Jan 2012) $') =~ s/.*\(\D+(\d+\s\w+\s\d+)\).+/$1/; #auto update upon commit

#----------------------------------------------------------------------------

#----------------------------------------------
sub getConfig {
# Receives name of the config file to parse, returns href with the loaded config
#----------------------------------------------
  my $file=shift || die "No config file provided";
  die "Cannot find config file $file\n" unless (-f $file);
  &showDebug("Loading config for $file\n",1);
  my %config = ParseConfig("$file") ;
  return \%config;

} #end getConfig


#----------------------------------------------
1; #tell the sourcing program we are true
