#!/usr/bin/perl
package Kline::Utils::HTML;
# HTML.pm
# Chris Kline; Chris.Kline@ca.com
# ---------------------------------------------------------------------------
#
# This script is a library of commonly used functions for Kline programs that
# use Perl.  It can be "sourced in" using the "require" pragma.
# This library contains only functions that perform html-related activities.
#
# ---------------------------------------------------------------------------
# REVISION HISTORY
# 1.0   11/12/12 Initial.


#
#-------------------------------------------------------------------------------
# Source Control Information
# $Revision: 57 $
# $LastChangedDate: 2012-11-20 13:19:30 -0700 (Tue, 20 Nov 2012) $
# $Author: cnkline $
#
# ---------------------------------------------------------------------------
# INITIALIZE THE ENVIRONMENT

use strict;
use English; 		#D:\perl_oreilly\prog\ch07_013.htm

use lib '../..'; #so we can run these direct to make sure they compile and not fail for missing mods
use lib '../../public'; #so we can run these direct to make sure they compile and not fail for missing mods
use Kline::Display;

use URI::Escape; #encoder


my $scriptVer="1.0.0";
my $scriptDate; #backward compatibility
($scriptDate = '$LastChangedDate: 2012-11-20 13:19:30 -0700 (Tue, 20 Nov 2012) $') =~ s/.*\(\D+(\d+\s\w+\s\d+)\).+/$1/; #auto update upon commit


#----------------------------------------------------------------------------



#----------------------------------------------
sub encodeURI(){
# Ensure that username and password are properly encoded for transmission on the URI
#----------------------------------------------
  my $string=shift || die "FATAL: incorrect args: $!\n";
  &showDebug("Encoding strings...",1); #don't log the actual string since it's likely to be a password
  #&showDebug("old string \"$string\"",1);
  my $new=&URI::Escape::uri_escape($string);
  #&showDebug("new string \"$new\"",1);

  return $new;

} #encodeURI

#----------------------------------------------
sub unencodeURI(){
# make characters pretty again
#----------------------------------------------
  my $string=shift || die "FATAL: incorrect args: $!\n";
  &showDebug("Unencoding strings...",1); 
  #&showDebug("old string \"$string\"",1);
  my $new=&URI::Escape::uri_unescape($string);
  #&showDebug("new string \"$new\"",1);

  return $new;

} #encodeURI


#----------------------------------------------
1; #tell the sourcing program we are true
