#!/usr/bin/perl
package Kline::Wily;
# Wily.pm
# Chris Kline; Chris.Kline@ca.com
# ---------------------------------------------------------------------------
#
# This script is a library of commonly used functions for Kline programs that
# use Perl.  It can be "sourced in" using the "require" pragma.
# This library contains only functions that perform display-related activities.
# These functions may call functions from other libraries.
#
# ---------------------------------------------------------------------------
# REVISION HISTORY
# 1.0.0  11/06/12 Initial.
#
#-------------------------------------------------------------------------------
# Source Control Information
# $Revision: 45 $
# $LastChangedDate: 2012-11-12 09:01:43 -0700 (Mon, 12 Nov 2012) $
# $Author: cnkline $
#
# ---------------------------------------------------------------------------
# INITIALIZE THE ENVIRONMENT

use strict;
use English; 		#D:\perl_oreilly\prog\ch07_013.htm
#require Exporter;
#our @ISA=qw(Exporter);
#our @EXPORT=qw(clear drawLine pressEnter printArrowSection printError printItem printItemCR printSection printTitle printTitleC dumpHref showDebug printFunctionNames);

#use File::Basename qw(basename);

use lib '..'; #so we can run these direct to make sure they compile and not fail for missing mods
#use Kline::Utils;
use Kline::Display;

my $scriptVer="1.0.0";
my $scriptDate; #backward compatibility
($scriptDate = '$LastChangedDate: 2012-11-12 09:01:43 -0700 (Mon, 12 Nov 2012) $') =~ s/.*\(\D+(\d+\s\w+\s\d+)\).+/$1/; #auto update upon commit

#----------------------------------------------
sub cleanMetric {
# Receives a metric value and cleans it up so it can be sent to EM
#----------------------------------------------
  my $m=shift;
  &showDebug("Cleaning metric $m",2);
  #drop non-numeric
  &showDebug("metric value before drop non-numeric: $m",3);
  $m=~s/([\d|\.]+)\D/$1/;
  &showDebug("metric value after drop non-numeric: $m",3);
  #round values
  if ($m=~/\.\d/) {
    $m=&Kline::Utils::roundInteger($m);
  }

  return $m;

} #end cleanMetric

#----------------------------------------------
1; #tell the sourcing program we are true
