#//////////////////////////////////////////////////////////////////////////////
#//
#//  NewDesktop.pl
#//  Win32::AdminMisc Perl extension test script to verify desktop functions
#//  are working correctly.
#//
#//  Copyright (c) 1998-2003 Dave Roth
#//  Courtesy of Roth Consulting
#//  http://www.roth.net/
#//
#//  This file may be copied or modified only under the terms of either 
#//  the Artistic License or the GNU General Public License, which may 
#//  be found in the Perl 5.0 source kit.
#//
#//  2003.07.14  :Date
#//  20030714    :Version
#//////////////////////////////////////////////////////////////////////////////

use Win32::AdminMisc 981228;

my $WinStation, $DeskTop;

if( $Arg = $ARGV[0] )
{
    ( $Temp, $WinStation, $DeskTop ) = ( $Arg =~ /((.*)\\)?(.*)/ )
}
else
{
    $Winstation = $DeskTop = 'Default';
}

if( Win32::AdminMisc::GetDeskTops( $WinStation, \@List ) )
{
    foreach ( @List )
    {
        if( lc( $_ ) eq lc( $DeskTop ) )
        {
            die "The '$DeskTop' desktop already exists.\n";
        }
    }
}

$Result = Win32::AdminMisc::CreateDeskTop( $DeskTop );
if( $Result )
{
    print "The '$DeskTop' desktop was successfully created.\n";
    Win32::AdminMisc::SwitchDeskTop( $DeskTop );
    Win32::AdminMisc::SwitchDeskTop( '' );
}
else
{
    print "The '$DeskTop' desktop creation failed.\n";
}
