#//////////////////////////////////////////////////////////////////////////////
#//
#//  RenameUser.pl
#//  Win32::AdminMisc Perl extension test script to verify user reanme function
#//  is working correctly.
#//
#//  Copyright (c) 1998-2003 Dave Roth
#//  Courtesy of Roth Consulting
#//  http://www.roth.net/
#//
#//  This file may be copied or modified only under the terms of either 
#//  the Artistic License or the GNU General Public License, which may 
#//  be found in the Perl 5.0 source kit.
#//
#//  2003.07.14  :Date
#//  20030714    :Version
#//////////////////////////////////////////////////////////////////////////////

use Win32;
use Win32::AdminMisc;

$Domain = "";
$Account = "";
$AccountNew = "";
$Prefix = "test_";

# As we rename accounts the PDC may not have time to sync with 
# BDCs. Therefore we should get the PDC and target it for
# the list of users...
if( Win32::AdminMisc::GetUsers( $Domain, $Prefix, \@Users ) )
{
    $Account = $Users[0];
    $AccountNew = join( "", reverse( split( //, $Account ) ) );

    print "Attempting to rename the user account '$Account' to '$AccountNew'\n";

    if( Win32::AdminMisc::RenameUser( $Domain, $Account, $AccountNew ) )
    {
        print "  Successfully renamed user '$Account' to '$AccountNew'\n";

        if( Win32::AdminMisc::RenameUser( $Domain, $AccountNew, $Account ) )
        {
            print "  Successfully renamed the user '$AccountNew' back to '$Account'\n";
        }
        else
        {
            print "  Unable to renamed the user '$AccountNew' back to '$Account'\n";
            print "  ERROR: " . DumpError();
        }
    }
    else
    {
        print "Could not rename the user '$Account' to '$AccountNew': " . DumpError();
    }
}
else
{
    print "Unable to find any test accounts to rename.\n";
}

print "Finished.\n";

sub DumpError
{
    return( Win32::FormatMessage( Win32::AdminMisc::GetError() ) . "\n" );
}
