#//////////////////////////////////////////////////////////////////////////////
#//
#//  Sched.pl
#//  Win32::AdminMisc Perl extension test script to verify scheudling functions
#//  are working correctly.
#//
#//  Copyright (c) 1998-2003 Dave Roth
#//  Courtesy of Roth Consulting
#//  http://www.roth.net/
#//
#//  This file may be copied or modified only under the terms of either 
#//  the Artistic License or the GNU General Public License, which may 
#//  be found in the Perl 5.0 source kit.
#//
#//  2003.07.14  :Date
#//  20030714    :Version
#//////////////////////////////////////////////////////////////////////////////

use Win32::AdminMisc;

srand( time() );
%DayOfWeek = (
    SUNDAY,       'Sunday',
    MONDAY,       'Monday',
    TUESDAY,      'Tuesday',
    WEDNESDAY,    'Wednesday',
    THURSDAY,     'Thursday',
    FRIDAY,       'Friday',
    SATURDAY,     'Saturday'
);

$Server = "\\\\main2";
$NumOfJobs = 15;

@List = AddJobs( $NumOfJobs );

#$Jobs = Win32::AdminMisc::ScheduleList( $Server, \%Jobs ); 
#if( defined $Jobs ) 
#{ 
#  print "$Jobs jobs on $Server\n\n"; 
#  foreach $Number (keys(%Jobs)){ 
#    print "Job $Number is $Jobs{$Number}->{Command}\n"; 
#    print "  DOM is $Jobs{$Number}->{DOM}\n"; 
#    print "  DOW is $Jobs{$Number}->{DOW}\n"; 
#    print "  Flags is $Jobs{$Number}->{Flags}\n"; 
#    print "  Time is $Jobs{$Number}->{Time}\n"; 
#  } 
#} 
#else
#{ 
#  print "ScheduleList failed\n"; 
#} 

foreach $i ( 1, 2, 3, 4, 55, 63 ) 
{ 
    CheckJob( $List[ $i ] );
}

sub CheckJob
{
    my( $Job ) = @_;
    my( %JobInfo );
    my( @DOW );

    if( 0 != Win32::AdminMisc::ScheduleGet( $Server, $Job, \%JobInfo ) )
    { 
        print "\n  ---------------------------------------\n";
        print "    Job #$Job\n"; 
        print "    Command is '$JobInfo{Command}'\n";
        print "    DOM   is $JobInfo{DOM}\n";
        print "    DOW   is $JobInfo{DOW}\n";
        print "    Flags is $JobInfo{Flags}\n";
        print "    Time  is $JobInfo{Time}\n";

        foreach $Day ( keys( %DayOfWeek ) ) 
        { 
            push( @DOW, $DayOfWeek{$Day} ) if( $JobInfo{DOW} & $Day ); 
        } 
        print "  This job $Job will run on the following days of the week:\n"; 
        print "    ", join( ", ", @DOW ), "\n\n"; 
    } 
} 

DelJobs( @List );

sub AddJobs
{
    my( $Total ) = @_;
    my @Jobs;

    for( my $iIndex = 0; $iIndex < $Total; $iIndex++ )
    {
        my $Command = "cmd.exe /c echo This is a scheduled job";
        my $Time = "4:00";
        my $DOM = 0;
        my $DOW = int( rand( 128 ) );
        my $Flags = JOB_RUN_PERIODICALLY;

        my $Result = Win32::AdminMisc::ScheduleAdd( $Server, $Time, $DOM, $DOW, $Flags, $Command . " ( # $iIndex )" );
        if( defined $Result )
        {
            print "New job $Result has been added.\n";
            push( @Jobs, $Result );
        }
        else
        {
            print "Failed to add job.\n";
        }
    }
    return( @Jobs );
}

sub DelJobs
{
    my( @Jobs ) = @_;

    foreach ( @Jobs )
    {
        print "Deleting job #$_...";
        if( 0 != Win32::AdminMisc::ScheduleDel( $Server, $_ ) )
        {
            print "Successful!\n";
        }
        else
        {
            print "Failed.\n";
        }
    }
}

sub RemoveJobs
{
    my( $Job, $Max ) = @_;

    my( @Options );

    push( @Options, $Job );
    push( @Options, $Max ) if( defined $Max );

    print "Removing jobs...$Job [, $Max ]\n";
    print Win32::AdminMisc::ScheduleDel( $Server, @Options );
}
