#//////////////////////////////////////////////////////////////////////////////
#//
#//  Sched2.pl
#//  Win32::AdminMisc Perl extension test script to verify scheduling functions
#//  are working correctly. This is the second test script for this functionality.
#//
#//  Copyright (c) 1998-2003 Dave Roth
#//  Courtesy of Roth Consulting
#//  http://www.roth.net/
#//
#//  This file may be copied or modified only under the terms of either 
#//  the Artistic License or the GNU General Public License, which may 
#//  be found in the Perl 5.0 source kit.
#//
#//  2003.07.14  :Date
#//  20030714    :Version
#//////////////////////////////////////////////////////////////////////////////

use Win32::AdminMisc; 

$Win32::AdminMisc::m_Debug = 1;

$srvr = "\\\\main2";
$Jobs = Win32::AdminMisc::ScheduleList($srvr, \%Jobs); 
if (defined $Jobs) 
{ 
  print "$Jobs jobs on $srvr\n\n"; 
  foreach $Number (keys(%Jobs)){ 
    print "Job $Number is $Jobs{$Number}->{Command}\n"; 
    print "  DOM is $Jobs{$Number}->{DOM}\n"; 
    print "  DOW is $Jobs{$Number}->{DOW}\n"; 
    print "  Flags is $Jobs{$Number}->{Flags}\n"; 
    print "  Time is $Jobs{$Number}->{Time}\n"; 
  } 
}else{ 
  print "ScheduleList failed\n"; 
} 

%v = (1,1,2,2,3,3,4,4,55,55,63,63); 

foreach $xi (keys %v) 
{ 
  $i = $xi + 1040; 
  print ".$i.\n"; 
  %JobInfo = (); 
  $xx = Win32::AdminMisc::ScheduleGet($srvr, $i, \%JobInfo); 
  if ($xx == 1) 
  { 
        print "Job $i is $JobInfo{Command}\n"; 
        print "  DOM is $JobInfo{DOM}\n"; 
        print "  DOW is $JobInfo{DOW}\n"; 
        print "  Flags is $JobInfo{Flags}\n"; 
        print "  Time is $JobInfo{Time}\n"; 

    foreach $Day (1..31){ 
        push(@DOM, $Day) if ($JobInfo{DOM} & 2**$Day); 
    } 
    print "This job $i will run on the following days of the month:\n"; 
    print join(", ", @DOM); 
  } 
} 
